﻿namespace UltraListViewWithCheckBoxes
{
    using System;
    using System.Windows.Forms;

    using Infragistics.Win;
    using Infragistics.Win.UltraWinListView;

    public partial class Form1 : Form
    {
        public Form1()
        {
            this.InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            this.ultraListView1.View = UltraListViewStyle.Details;
            this.ultraListView1.ViewSettingsDetails.CheckBoxStyle = CheckBoxStyle.CheckBox;

            MyCreationFilter filter = new MyCreationFilter();
            this.ultraListView1.CreationFilter = filter;
            filter.Clicked += Filter_Clicked;

            this.ultraListView1.Items.Add("First", new MyItems("First", DateTime.Now));
            this.ultraListView1.Items.Add("Second", new MyItems("Second", DateTime.Now.AddDays(1)));
            this.ultraListView1.Items.Add("Third", new MyItems("Third", DateTime.Now.AddDays(2)));

            this.ultraListView1.MainColumn.Text = "Header";
        }

        private void Filter_Clicked(object sender, Infragistics.Win.UIElementEventArgs e)
        {
            CheckBoxUIElement checkBox = e.Element as CheckBoxUIElement;
            if (checkBox == null)
            {
                return;
            }

            foreach (var item in this.ultraListView1.Items)
            {
                item.CheckState = checkBox.CheckState;
            }
        }
    }
}
