﻿namespace UltraListViewWithCheckBoxes
{
    using System.Drawing;

    using Infragistics.Win;
    using Infragistics.Win.UltraWinListView;

    public class MyCreationFilter : IUIElementCreationFilter
    {
        private CheckBoxUIElement checkBox;

        public delegate void HeaderCheckBoxClickedHandler(object sender, UIElementEventArgs e);

        public event HeaderCheckBoxClickedHandler Clicked;

        public void AfterCreateChildElements(UIElement parent)
        {
            if (parent is UltraListViewColumnHeaderUIElement)
            {
                UltraListViewColumnBase column = ((UltraListViewColumnHeaderUIElement)parent).Column;
                if (column != null && column.Text == "Header")
                {
                    if (this.checkBox == null)
                    {
                        this.checkBox = new CheckBoxUIElement(parent);
                    }

                    this.checkBox.ElementClick += this.CheckBox_ElementClick;
                    parent.ChildElements.Add(this.checkBox);
                    this.checkBox.Rect = new Rectangle(parent.Rect.X + 3, parent.Rect.Y + 3, this.checkBox.CheckSize.Width, this.checkBox.CheckSize.Height);

                    TextUIElement columnHeader = (TextUIElement)parent.GetDescendant(typeof(TextUIElement));
                    columnHeader.Rect = new Rectangle(columnHeader.Rect.X + this.checkBox.Rect.Width + 3, columnHeader.Rect.Y, columnHeader.Rect.Width, columnHeader.Rect.Height);
                }
            }
        }

        public void CheckBox_ElementClick(object sender, UIElementEventArgs e)
        {
            if (this.Clicked != null)
            {
                this.Clicked.Invoke(sender, e);
            }
        }

        public bool BeforeCreateChildElements(UIElement parent)
        {
            return false;
        }
    }
}